﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI;
using Windows.UI.Text;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace Win8App
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override async void OnNavigatedTo(NavigationEventArgs e)
        {
            if (!(DataContext is ViewModel))
            {
                var vm = new ViewModel();
                DataContext = vm;
                await vm.Initialize();

            }
        }

        private void ButtonBase_OnClick(object sender, RoutedEventArgs e)
        {
            var selection = Box.Document.Selection;
            if (selection != null)
            {
                selection.CharacterFormat.Italic = FormatEffect.Toggle;
            }
        }

        private void FindBox_OnTextChanged(object sender, TextChangedEventArgs e)
        {
            var range = Box.Document.GetRange(0, int.MaxValue);
            range.Move(TextRangeUnit.Character, 0);
            range.CharacterFormat.BackgroundColor = Colors.White;

            range.Move(TextRangeUnit.Character, 0);

            while (range.FindText(FindBox.Text, int.MaxValue, FindOptions.None) > 0)
            {
                range.CharacterFormat.BackgroundColor = Colors.Yellow;
            }
        }

    }
}
